<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Cnc00400ConciliacaoManualFactory {
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function leftGridSelect ($params) {
        $sql = "SELECT RV.CDNSU, RV.NRAUTORIZACAO, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NMPRODUTOADQ, 
                  RV.VRBRUTVENDA, RV.NRCONCLANC, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, E.CDESTABELEC, E.NMESTABELEC, 
                  RV.NRCONCLANCPGTO, RV.NRRETVENDAADQ CHAVE, A.NMADQUIRENTE, RV.VRLIQVENDA, RV.NRTERMINAL,
                  TO_CHAR(RV.DTCREDITO, 'DD/MM/YYYY') DTCREDITO,
                  RV.NRLANCTONF, E.CDFILIAL, A.NRADQUIRENTE, LPAD(TO_CHAR(RV.NRPARCELA), 2, '0') AS NRPARCELA
                FROM RETVENDAADQ RV 
                LEFT JOIN CONCILIACAOLANC CON
                  ON RV.NRCONCLANC = CON.NRCONCLANC, ADQUIRENTE A, PRODUTOADQ P, ESTABELECIMENTO E
                WHERE RV.NRADQUIRENTE = A.NRADQUIRENTE
                  AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ 
                  AND RV.NRESTABELEC = E.NRESTABELEC
                  AND RV.NRORG = :NRORG
                  AND ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(RV.NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')
                  AND ((INSTR (:NRADQUIRENTE, '|'||TO_CHAR(RV.NRADQUIRENTE)||'|') > 0) OR :TNRADQUIRENTE = 'T')
                  AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(RV.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND ((UPPER(RV.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                  AND ((INSTR (:STATUS, RV.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                ORDER BY RV.DTVENDA, E.NMESTABELEC, E.CDESTABELEC, A.NMADQUIRENTE, P.NMPRODUTOADQ, DTCREDITO, RV.VRBRUTVENDA, RV.CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function rightGridSelect ($params) {
        $sql = "SELECT T.CDNSU, T.NRAUTORIZACAO, T.DTVENDA, T.NMPRODUTOADQ,
                       T.VRBRUTVENDA, T.NRCONCLANC, T.IDCONCILIADO,
                       T.NRCONCLANCPGTO, T.CHAVE, T.DTCREDITO,
                       T.DRECEBE, T.NRLANCTONF, T.CDFILIALNF, T.CDFILIAL, T.NMFILIAL,
                       (T.VRBRUTVENDA - (T.VRBRUTVENDA * (NVL(TF.VRTAXAADMFIL, T.VRTAXAADMI)/100))) AS VRLIQVENDA,
                       T.NRPARCELA, T.NMTIPORECE
                 FROM (SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NMPRODUTOADQ, 
                                      C.VRVENDA VRBRUTVENDA, C.NRCONCLANC, DECODE(C.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, 
                                      null NRCONCLANCPGTO, C.NRCONSMOVCAIXA CHAVE,
                                      TO_CHAR(NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)), 'DD/MM/YYYY') DTCREDITO,
                                      NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)) - C.DTVENDA AS DRECEBE,
                                      C.NRLANCTONF, C.CDFILIALNF, EF.CDFILIAL, F.NMFILIAL, NVL(TPRECE.VRTAXAADMI, 0) VRTAXAADMI,
                                      LPAD(TO_CHAR(C.NRPARCELA), 2, '0') AS NRPARCELA, TPRECE.NMTIPORECE, C.CDTIPORECE
                                 FROM CONSMOVCAIXA C 
                                 LEFT JOIN CONCILIACAOLANC CON
                                   ON C.NRCONCLANC = CON.NRCONCLANC
                                 LEFT JOIN TIPORECE TPRECE
                                   ON TPRECE.CDTIPORECE = C.CDTIPORECE
                                 LEFT JOIN TPRECEPRODADQ TP
                                   ON C.CDTIPORECE = TP.CDTIPORECE
                                 LEFT JOIN PRODUTOADQ P
                                   ON P.NRPRODUTOADQ = TP.NRPRODUTOADQ,
                                      (SELECT DISTINCT CDFILIAL
                                       FROM ESTABELECIMENTO
                                       WHERE ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')) EF
                                 JOIN FILIAL F
                                   ON F.CDFILIAL = EF.CDFILIAL
                                WHERE C.CDFILIAL = EF.CDFILIAL
                                  AND C.NRORG = :NRORG                  
                                  AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
                                  AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                                  AND ((UPPER(C.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                                  AND ((INSTR (:STATUS, C.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                                ORDER BY DTVENDA, F.NMFILIAL, P.NMPRODUTOADQ, C.VRVENDA, C.CDNSU) T
                         LEFT JOIN TIPORECEFILIAL TF
                           ON TF.CDFILIAL = T.CDFILIAL
                           AND TF.CDTIPORECE = T.CDTIPORECE";
                 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function rightGridSelectVisibleProducts ($params) {
        $sql = "SELECT T.CDNSU, T.NRAUTORIZACAO, T.DTVENDA, T.NMPRODUTOADQ,
                       T.VRBRUTVENDA, T.NRCONCLANC, T.IDCONCILIADO,
                       T.NRCONCLANCPGTO, T.CHAVE, T.DTCREDITO,
                       T.DRECEBE, T.NRLANCTONF, T.CDFILIALNF, T.CDFILIAL, T.NMFILIAL,
                       (T.VRBRUTVENDA - (T.VRBRUTVENDA * (NVL(TF.VRTAXAADMFIL, T.VRTAXAADMI)/100))) AS VRLIQVENDA,
                       T.NRPARCELA, T.NMTIPORECE, T.ISNULL
                  FROM ( SELECT * FROM
                              (SELECT T.*, DECODE(T.PRODUTOS, 0, 'N', 'S') ISNULL FROM 
                                    (SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, P.NRPRODUTOADQ, NVL(P.NRPRODUTOADQ, 0) PRODUTOS, P.NMPRODUTOADQ, C.VRVENDA VRBRUTVENDA, C.NRCONCLANC, 
                                      DECODE(C.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, null NRCONCLANCPGTO, C.NRCONSMOVCAIXA CHAVE,
                                      TO_CHAR(NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)), 'DD/MM/YYYY') DTCREDITO,
                                      NVL(C.DTVENCIMENTO, CNC_DATA_VENC(C.CDFILIAL, C.DTVENDA, NVL(P.NRDIASVENC, 0), C.CDTIPORECE)) - C.DTVENDA AS DRECEBE,
                                      C.NRLANCTONF, C.CDFILIALNF, EF.CDFILIAL, F.NMFILIAL, NVL(TPRECE.VRTAXAADMI, 0) VRTAXAADMI,
                                      LPAD(TO_CHAR(C.NRPARCELA), 2, '0') AS NRPARCELA, TPRECE.NMTIPORECE, C.CDTIPORECE
                                    FROM CONSMOVCAIXA C 
                                    LEFT JOIN CONCILIACAOLANC CON
                                      ON C.NRCONCLANC = CON.NRCONCLANC
                                    LEFT JOIN TIPORECE TPRECE
                                      ON TPRECE.CDTIPORECE = C.CDTIPORECE
                                    LEFT JOIN TPRECEPRODADQ TP
                                      ON C.CDTIPORECE = TP.CDTIPORECE
                                    LEFT JOIN PRODUTOADQ P
                                      ON P.NRPRODUTOADQ = TP.NRPRODUTOADQ, 
                                      (SELECT DISTINCT CDFILIAL
                                        FROM ESTABELECIMENTO
                                       WHERE ((INSTR (:NRESTABELEC,  '|'||TO_CHAR(NRESTABELEC)||'|') > 0) OR :TNRESTABELEC = 'T')) EF
                                    JOIN FILIAL F
                                      ON F.CDFILIAL = EF.CDFILIAL
                                    WHERE C.CDFILIAL = EF.CDFILIAL
                                      AND C.NRORG = :NRORG                  
                                      AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(P.NRPRODUTOADQ)||'|') > 0) OR :TNRPRODUTOADQ = 'T')
                                      AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                                      AND ((UPPER(C.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                                      AND ((INSTR (:STATUS, C.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                                    ORDER BY DTVENDA, F.NMFILIAL, P.NMPRODUTOADQ, C.VRVENDA, C.CDNSU)T)Q
                                    WHERE Q.ISNULL = 'S' ) T
                                    
                                         LEFT JOIN TIPORECEFILIAL TF
                                           ON TF.CDFILIAL = T.CDFILIAL
                                           AND TF.CDTIPORECE = T.CDTIPORECE
                ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectConciliacoesPagto ($params) {
        $sql = "SELECT RF.CDNSU, TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA, RF.VRBRUTVENDA, null VRLIQVENDA, RF.VRLIQPGTO, 
                  null VRTAXAPREV, RF.VRCOBRADOTAXA, DECODE(RF.NRCONCLANC, null, 'P', 'C') IDCONCILIADO, 
                  DECODE(RF.NRANTECIPACAO, NULL, 'N', 'A') IDSTATUSVENDA,
                  DECODE(CON.IDTPCONCILIACAO, 'A', 'Automática', 'M', 'Manual', NULL, 'Não Conciliada') IDTIPOCONCILIACAO,
                  RF.NRCONCLANC NRCONCLANC, RF.NRCONCLANC NRCONCLANCPGTO, RF.NRRETFINANCADQ, null NRRETVENDAADQ
                FROM RETFINANCADQ RF LEFT JOIN CONCILIACAOLANC CON
                  ON RF.NRCONCLANC = CON.NRCONCLANC
                WHERE RF.NRORG = :NRORG
                  AND RF.NRESTABELEC = :NRESTABELEC
                  AND RF.NRADQUIRENTE = :NRADQUIRENTE
                  AND RF.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND ((UPPER(RF.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                  AND (RF.VRBRUTVENDA >= REPLACE(:VALINICIAL, '%', '') OR 'U' = :UVALINICIAL)
                  AND (RF.VRBRUTVENDA <= REPLACE(:VALFINAL, '%', '') OR 'U' = :UVALFINAL)
                  AND ((INSTR (:STATUS, RF.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                  AND REPLACE(:TIPOPGTO, '%', '') = 'R'
                UNION ALL
                SELECT RV.CDNSU, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.VRBRUTVENDA, RV.VRLIQVENDA, null VRLIQPGTO,
                  RV.VRTAXAPREV VRTAXA, null VRCOBRADOTAXA, DECODE(RV.NRCONCLANCPGTO, null, 'P', 'C') IDCONCILIADO, NULL IDSTATUSVENDA, 
                  DECODE(CON.IDTPCONCILIACAO, 'A', 'Automática', 'M', 'Manual', NULL, 'Não Conciliada') IDTIPOCONCILIACAO,
                  RV.NRCONCLANCPGTO NRCONCLANC, RV.NRCONCLANCPGTO, null RETFINANCADQ, RV.NRRETVENDAADQ
                FROM RETVENDAADQ RV LEFT JOIN CONCILIACAOLANC CON
                  ON RV.NRCONCLANC = CON.NRCONCLANC
                WHERE RV.NRORG = :NRORG
                  AND RV.NRESTABELEC = :NRESTABELEC
                  AND RV.NRADQUIRENTE = :NRADQUIRENTE
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND ((UPPER(RV.CDNSU) LIKE UPPER('%'||:CDNSU||'%')) OR ('T' = :TCDNSU))
                  AND (RV.VRBRUTVENDA >= REPLACE(:VALINICIAL, '%', '') OR 'U' = :UVALINICIAL)
                  AND (RV.VRBRUTVENDA <= REPLACE(:VALFINAL, '%', '') OR 'U' = :UVALFINAL)
                  AND ((INSTR (:STATUS, RV.IDCONCILIADO) > 0) OR ('T' = :TSTATUS))
                  AND REPLACE(:TIPOPGTO, '%', '') = 'V'
                  AND RV.NRCONCLANC IS NOT NULL
                ORDER BY 2, 11, 1";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabSisMovimentacoes ($params) {
        $sql = "SELECT RV.CDNSU, RV.NRAUTORIZACAO, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, A.NMADQUIRENTE, P.NMPRODUTOADQ, 
                  RV.VRBRUTVENDA, RV.NRCONCLANC, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, RV.NRCONCLANCPGTO, 
                  RV.NRRETVENDAADQ, CON.CDOPERINCLUSAO, TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO,
                  TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU
                FROM RETVENDAADQ RV LEFT JOIN CONCILIACAOLANC CON
                  ON RV.NRCONCLANC = CON.NRCONCLANC, 
                ADQUIRENTE A, PRODUTOADQ P
                WHERE RV.NRADQUIRENTE = A.NRADQUIRENTE
                  AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ
                  AND RV.NRORG = :NRORG
                  AND ((RV.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (RV.NRCONCLANC IS NULL AND :ISNULL = 'S'))
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:IDCONCILIADO, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C')) > 0)
                ORDER BY CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabAdqMovimentacoes ($params) {
        $sql = "SELECT C.CDNSU, C.NRAUTORIZACAO, TO_CHAR(C.DTVENDA, 'DD/MM/YYYY') DTVENDA, C.VRVENDA VRBRUTVENDA,
                  C.NRCONCLANC, DECODE(C.IDCONCILIADO, 'P', 'P', 'C') IDCONCILIADO, C.NRCONSMOVCAIXA, CON.CDOPERINCLUSAO,
                  TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO, 
                  TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU
                FROM CONSMOVCAIXA C LEFT JOIN CONCILIACAOLANC CON
                  ON C.NRCONCLANC = CON.NRCONCLANC
                WHERE C.NRORG = :NRORG
                  AND ((C.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (C.NRCONCLANC IS NULL AND :ISNULL = 'S'))
                  AND C.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:IDCONCILIADO, DECODE(C.IDCONCILIADO, 'P', 'P', 'C')) > 0)
                ORDER BY CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabVndMovimentacoes ($params) {
        $sql = "SELECT RF.CDNSU, TO_CHAR(RF.DTVENDA, 'DD/MM/YYYY') DTVENDA, RF.VRBRUTVENDA, RF.VRLIQPGTO, 
                  RF.VRCOBRADOTAXA, DECODE(RF.NRANTECIPACAO, NULL, 'N', 'A') IDANTECIPACAO, RF.NRCONCLANC, CON.CDOPERINCLUSAO, 
                  TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO, CON.IDTPCONCILIACAO, TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU,
                  RF.NRRETFINANCADQ, RF.IDCONCILIADO
                FROM RETFINANCADQ RF LEFT JOIN CONCILIACAOLANC CON
                  ON RF.NRCONCLANC = CON.NRCONCLANC
                WHERE RF.NRORG = :NRORG
                  AND RF.NRADQUIRENTE = :NRADQUIRENTE
                  AND ((RF.NRCONCLANC = :NRCONCLANC AND :ISNULL = 'N') OR (RF.NRCONCLANC IS NULL AND :ISNULL = 'S'))
                  AND RF.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:IDCONCILIADO, DECODE(RF.IDCONCILIADO, 'P', 'P', 'C')) > 0)
                ORDER BY CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectTabRetMovimentacoes ($params) {
        $sql = "SELECT RV.CDNSU, TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, RV.VRBRUTVENDA, RV.VRLIQVENDA, 
                  RV.VRTAXAPREV, RV.NRCONCLANCPGTO, CON.CDOPERINCLUSAO, TO_CHAR(CON.DTCONCILIACAO, 'DD/MM/YYYY') DTCONCILIACAO,
                  CON.IDTPCONCILIACAO, TO_CHAR(CON.DTULTATU, 'DD/MM/YYYY') DTULTATU, RV.NRRETVENDAADQ,
                  DECODE(RV.NRCONCLANCPGTO, null, 'P', 'C') IDCONCILIADO
                FROM RETVENDAADQ RV LEFT JOIN CONCILIACAOLANC CON
                  ON RV.NRCONCLANCPGTO = CON.NRCONCLANC
                WHERE RV.NRORG = :NRORG
                  AND RV.NRADQUIRENTE = :NRADQUIRENTE
                  AND ((RV.NRCONCLANCPGTO = :NRCONCLANCPGTO AND :ISNULL = 'N') OR (RV.NRCONCLANCPGTO IS NULL AND :ISNULL = 'S'))
                  AND RV.DTVENDA BETWEEN :DTVENDA_MIN AND :DTVENDA_MAX
                  AND (INSTR (:IDCONCILIADO, DECODE(RV.IDCONCILIADO, 'P', 'P', 'C')) > 0)
                ORDER BY CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function selectRetVendaInfo ($params) {
        $sql = "SELECT RV.*, P.CDTIPORECE
                  FROM RETVENDAADQ RV
                  LEFT JOIN (SELECT MAX(T.CDTIPORECE) CDTIPORECE, T.NRPRODUTOADQ FROM TPRECEPRODADQ T GROUP BY T.NRPRODUTOADQ) P
                    ON P.NRPRODUTOADQ =  RV.NRPRODUTOADQ
                 WHERE RV.NRRETVENDAADQ = :NRRETVENDAADQ
                   AND RV.NRORG = :NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll()[0];
    }
    
    public function checkItemCorrecao ($params) {
        $sql = "SELECT NRITEMCORRECAO
                FROM ITEMCORRECAO
                WHERE UPPER(DSITEMCORRECAO) LIKE UPPER(:DSITEMCORRECAO)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function updateConsWithVndValues ($params) {
        $sql = "UPDATE CONSMOVCAIXA
                SET CDNSU = :CDNSU,
                    NRAUTORIZACAO = :NRAUTORIZACAO,
                    CDTIPORECE = :CDTIPORECE,
                    NRQTPARCELA = :NRQTPARCELA,
                    NRPARCELA = :NRPARCELA,
                    VRVENDA = :VRVENDA,
                    DTVENDA = :DTVENDA,
                    DTVENCIMENTO = :DTVENCIMENTO,
                    IDSITUACAO = 'O'
                WHERE NRORG = :NRORG
                  AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function apagaContasPrevistas ($params) {
        $sql = "DELETE FROM LANCCONT L
                WHERE EXISTS (SELECT 1
                                FROM AJCTRECEBER A
                               WHERE A.CDFILIAL = :CDFILIAL
                                 AND A.NRLANCTONF = :NRLANCTONF
                                 AND A.CDECTBAJREC = L.CDEMPRESA
                                 AND A.NRLCTBAJREC = L.NRLANCCONT)";
        
        $bool = true;
        
        $std  = $this->connection->prepare($sql);
        $bool = $bool && $std->execute($params);
        
        $sql = "DELETE
                FROM AJCTRECEBER
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
                  
        $std  = $this->connection->prepare($sql);
        $bool = $bool && $std->execute($params);
        
        $sql = "DELETE
                FROM CONTARECEBER
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
                  
        $std  = $this->connection->prepare($sql);
        $bool = $bool && $std->execute($params);
        
        $sql = "SELECT DISTINCT B.NRLANBOLREC, B.CDFILIAL
                     FROM BOLETRECEBER B, CONTARECEBER C
                    WHERE B.CDFILIAL = C.CDFILIBOLREC
                      AND B.NRLANBOLREC = C.NRLANBOLREC
                      AND C.CDFILIAL = :CDFILIAL
                      AND C.NRLANCTONF = :NRLANCTONF";
                      
        $std  = $this->connection->prepare($sql);
        $std->execute($params);
        $resultSet = $std->fetchAll();
        
        foreach($resultSet as $resultLine) {
            $sql = "DELETE
                    FROM BOLETRECEBER
                    WHERE CDFILIAL = :CDFILIAL
                      AND NRLANBOLREC = :NRLANBOLREC";
            
            $std  = $this->connection->prepare($sql);
            $bool = $bool && $std->execute(array(
                ":CDFILIAL"    => $resultLine["CDFILIAL"],
                ":NRLANBOLREC" => $resultLine["NRLANBOLREC"]
            ));
        }
        
        $sql = "UPDATE RETVENDAADQ
                SET CDFILIAL = NULL,
                    NRLANCTONF = NULL
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
                  
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateConsMovCaixaBeforeDelete ($params) {
        $sql = "UPDATE CONSMOVCAIXA
                SET CDFILIALNF = NULL,
                    NRLANCTONF = NULL
                WHERE CDFILIALNF = :CDFILIALNF
                  AND NRLANCTONF = :NRLANCTONF";
                  
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteFromNotaFiscal ($params) {
        $sql = "DELETE
                FROM NOTAFISCAL
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
                  
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtRetVendaAdq ($params) {
        $sql = "UPDATE RETVENDAADQ
                SET NRCONCLANC = null,
                    NRCONCLANCPGTO = null,
                    IDCONCILIADO = 'P',
                    IDSITUACAO = 'N'
                WHERE NRORG = :NRORG
                  AND NRCONCLANC = :NRCONCLANC";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyConcPgtoAtRetVendaAdq ($params) {
        $sql = "UPDATE RETVENDAADQ
                SET NRCONCLANCPGTO = null,
                    IDCONCILIADO = 'I',
                    IDSITUACAO = 'C'
                WHERE NRORG = :NRORG
                  AND NRCONCLANCPGTO = :NRCONCLANCPGTO";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtRetFinancAdq ($params) {
        $sql = "UPDATE RETFINANCADQ
                SET NRCONCLANC = null,
                    IDCONCILIADO = 'P',
                    IDSITUACAO = 'N'
                WHERE NRORG = :NRORG
                  AND NRCONCLANC = :NRCONCLANC";
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function nullifyRowsAtConsMovCaixa ($params) {
        $sql = "UPDATE CONSMOVCAIXA
                SET NRCONCLANC = null,
                    IDCONCILIADO = 'P',
                    IDSITUACAO = 'N'
                WHERE NRORG = :NRORG
                  AND NRCONCLANC = :NRCONCLANC";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    } 
    
    public function deleteFromDivConciliacao ($params) {
        $sql = "DELETE FROM DIVCONCILIACAO
                WHERE NRORG = :NRORG
                  AND NRCONCLANC = :NRCONCLANC";
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteFromConciliacaoLanc ($params) {
        $sql = "DELETE FROM CONCILIACAOLANC
                WHERE NRORG = :NRORG
                  AND NRCONCLANC = :NRCONCLANC";
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function insertAtConciliacaoLanc ($params) {
        $sql = "INSERT INTO CONCILIACAOLANC
                  (NRCONCLANC, DTCONCILIACAO, IDTPCONCILIACAO, NRDIVCONCILIACAO, NRORG,
                  IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU,
                  CDOPERULTATU)
                VALUES 
                  (:NRCONCLANC, TO_DATE(:DTCONCILIACAO, 'DD/MM/YYYY'), :IDTPCONCILIACAO, 
                  :NRDIVCONCILIACAO, :NRORG, :IDATIVO, TO_DATE(:DTINCLUSAO, 'DD/MM/YYYY'), 
                  TO_DATE(:DTULTATU, 'DD/MM/YYYY'), :NRORGINCLUSAO, :CDOPERINCLUSAO, :NRORGULTATU,
                  :CDOPERULTATU)";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function deleteItemCorVenda ($params) {
        $sql = "DELETE FROM ITEMCORVENDA
                WHERE NRORG = :NRORG
                  AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA";
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function insertItemCorVenda ($params) {
        $sql = "INSERT INTO ITEMCORVENDA
                  (NRITEMCORVENDA, NRCONSMOVCAIXA, NRITEMCORRECAO,
                  VRANTIGO, VRNOVO, NRORG)
                VALUES 
                  (:NRITEMCORVENDA, :NRCONSMOVCAIXA, :NRITEMCORRECAO, 
                  :VRANTIGO, :VRNOVO, :NRORG)";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetVendaAdq ($params) {
        $sql = "UPDATE RETVENDAADQ
                SET NRCONCLANC = :NRCONCLANC,
                    IDCONCILIADO = :IDCONCILIADO,
                    IDSITUACAO = :IDSITUACAO
                WHERE NRRETVENDAADQ = :NRRETVENDAADQ";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetVendaAdqLanctoNf ($params) {
        $sql = "UPDATE RETVENDAADQ
                SET NRLANCTONF = :NRLANCTONF,
                    CDFILIAL   = :CDFILIALNF
                WHERE NRRETVENDAADQ = :NRRETVENDAADQ";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updatePgtoRetVendaAdq ($params) {
        $sql = "UPDATE RETVENDAADQ
                SET NRCONCLANCPGTO = :NRCONCLANCPGTO,
                    IDCONCILIADO = :IDCONCILIADO,
                    IDSITUACAO = :IDSITUACAO
                WHERE NRRETVENDAADQ = :NRRETVENDAADQ";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateConsMovCaixa ($params) {
        $sql = "UPDATE CONSMOVCAIXA
                SET NRCONCLANC = :NRCONCLANC,
                    IDCONCILIADO = :IDCONCILIADO,
                    IDSITUACAO = :IDSITUACAO
                WHERE NRCONSMOVCAIXA = :CHAVE";
                
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function updateRetFinancAdq ($params) {
        $sql = "UPDATE RETFINANCADQ
                SET NRCONCLANC = :NRCONCLANC,
                    IDCONCILIADO = :IDCONCILIADO,
                    IDSITUACAO = :IDSITUACAO
                WHERE NRRETFINANCADQ = :NRRETFINANCADQ";
                
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function getErrors($params){
        $sql = "SELECT COUNT(*) QT
                              FROM ERROCTBTEMP
                             WHERE CDEMPRESA = :CDEMPRESA
                               AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getError($params){
        $sql = "SELECT CDERROTEMP, NRSEQCTBTEMP
                              FROM ERROCTBTEMP
                             WHERE CDEMPRESA = :CDEMPRESA
                               AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function deleteErrors($params){
        $sql = "DELETE
                      FROM ERROCTBTEMP
                     WHERE CDEMPRESA = :CDEMPRESA
                       AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        $sql = "DELETE
                      FROM LANCCTBTEMP
                     WHERE CDEMPRESA = :CDEMPRESA
                       AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
         $sql = "DELETE
                      FROM RATECTBTEMP
                     WHERE CDEMPRESA = :CDEMPRESA
                       AND NRLANCCTBTEMP = :NRLANCCTBTEMP"; 
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
    }
    
    public function verificaGeraFinanc($params){
        $sql = "SELECT IDGERAFINANC 
                    FROM ADQUIRENTE
                    WHERE NRADQUIRENTE = :NRADQUIRENTE ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);     
        return $std->fetch();
        
    }
    
    public function getNameProdutoadq($param){
        $sql = "SELECT NMPRODUTOADQ 
                    FROM PRODUTOADQ
                    WHERE NRPRODUTOADQ = :NRPRODUTOADQ";
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        return $std->fetch();
    }

    public function searchParamsCnc($params){
        try{ 
            switch($params[':P_TIPOPARAM']){
                case 'TIPODEB':
                    $sql = "SELECT BUSCA_PARAMETRO_CNC(
                                      :P_NRESTABELEC,
                                      :P_NRADQUIRENTE,
                                      :P_NRPRODUTOADQ,
                                      :P_TIPOPARAM,
                                      :P_GRAVAERRO,
                                      :P_DTINICIAL,
                                      :P_DTFINAL) AS CDTPDEBIBANC FROM DUAL";
                    break;            
                case 'TIPOCRED':
                    $sql = "SELECT BUSCA_PARAMETRO_CNC(
                                      :P_NRESTABELEC,
                                      :P_NRADQUIRENTE,
                                      :P_NRPRODUTOADQ,
                                      :P_TIPOPARAM,
                                      :P_GRAVAERRO,
                                      :P_DTINICIAL,
                                      :P_DTFINAL) AS CDTPCREDBANC FROM DUAL";
                    break;                  
                case 'TIPOCONTA':
                    $sql = "SELECT BUSCA_PARAMETRO_CNC(
                                      :P_NRESTABELEC,
                                      :P_NRADQUIRENTE,
                                      :P_NRPRODUTOADQ,
                                      :P_TIPOPARAM,
                                      :P_GRAVAERRO,
                                      :P_DTINICIAL,
                                      :P_DTFINAL) AS CDTPCTRECEB FROM DUAL";
                    break;
                case 'TIPOAJUSTE':
                    $sql = "SELECT BUSCA_PARAMETRO_CNC(
                                      :P_NRESTABELEC,
                                      :P_NRADQUIRENTE,
                                      :P_NRPRODUTOADQ,
                                      :P_TIPOPARAM,
                                      :P_GRAVAERRO,
                                      :P_DTINICIAL,
                                      :P_DTFINAL) AS CDAJUCTREC FROM DUAL";
                    break;
                case 'TIPOOPER':
                    $sql = "SELECT BUSCA_PARAMETRO_CNC(
                                      :P_NRESTABELEC,
                                      :P_NRADQUIRENTE,
                                      :P_NRPRODUTOADQ,
                                      :P_TIPOPARAM,
                                      :P_GRAVAERRO,
                                      :P_DTINICIAL,
                                      :P_DTFINAL) AS CDTIPOOPER FROM DUAL";
                    break;
                
            }
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function verifyInfoConsmov($param){ 
        $sql = "SELECT DISTINCT CONS.NRCONCLANC, CONS.NRCONSMOVCAIXA, CONS.CDFILIAL, CONS.CDFILIALNF, CONS.NRLANCTONF, CTR.CDTPCTRECEB,
                CTR.DTATUAVENREC, CONS.DTVENDA, CONS.CDTIPORECE,
                NF.CDTIPOOPER, NF.CDEMPRESA CDEMPRESA_NF, NF.CDINSCESTA CDINSCESTA_NF, NF.CDINSCMUNI CDINSCMUNI_NF, NF.CDSERIE CDSERIE_NF, NF.CDCLIENTE,
                EST.CDEMPRESA CDEMPRESA_ESTABELEC, EST.CDINSCESTA CDINSCESTA_ESTABELEC, EST.CDINSCMUNI CDINSCMUNI_ESTABELEC, EST.CDSERIE CDSERIE_ESTABELEC,
                CONS.DTVENCIMENTO, LPAD(TO_CHAR(CONS.NRPARCELA), 2, '0') AS NRPARCELA, LPAD(TO_CHAR(CONS.NRQTPARCELA), 2, '0') AS NRQTPARCELA
        FROM CONSMOVCAIXA CONS
            JOIN NOTAFISCAL NF
              ON NF.CDFILIAL = CONS.CDFILIALNF
              AND NF.NRLANCTONF = CONS.NRLANCTONF
            LEFT JOIN CONTARECEBER CTR
              ON CTR.CDFILIAL = CONS.CDFILIALNF
              AND CTR.NRLANCTONF = CONS.NRLANCTONF
            JOIN ESTABELECIMENTO EST
              ON EST.CDFILIAL = CONS.CDFILIAL
        WHERE CONS.NRCONSMOVCAIXA = :NRCONSMOVCAIXA
          AND CONS.NRORG = :NRORG";
            
        $std = $this->connection->prepare($sql);
        $std->execute($param);
        $retorno = $std->fetch();
        
        if(!$retorno){
            try{ 
                $procedure = new StoredProcedure($this->connection, 'FINANCEIRO_FOS_CNC');
                $procedure->addParam(new Param('P_NRCONSMOVCAIXA', Param::PARAM_INPUT, $param[':NRCONSMOVCAIXA']));
                $procedure->execute();
                $std = $this->connection->prepare($sql);
                $std->execute($param);
                $retorno = $std->fetch();
            } catch (\Exception $e) {
                    throw $e;
            }
        }
        return $retorno;
    }
    
    public function updateNotaFiscal($params){
        try{
            $sql = " UPDATE NOTAFISCAL
                  SET CDEMPRESA  = :CDEMPRESA,
                      CDINSCESTA = :CDINSCESTA,
                      CDINSCMUNI = :CDINSCMUNI,
                      CDSERIE    = :CDSERIE,
                      CDTIPOOPER = :CDTIPOOPER,
                      NRNOTAFISC = :NRNOTAFISC,
                      CDCLIENTE  = :CDCLIENTE
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF ";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateContaReceber($params){
        try{
            $sql = " UPDATE CONTARECEBER
                  SET CDTPCTRECEB  = :CDTPCTRECEB,
                      DTATUAVENREC = :DTATUAVENREC,
                      IDREPFOSCNC  = :IDREPFOSCNC,
                      DSCONTAREC   = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', '')
                 WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function updateContaReceberGeral($params){
        try{
            $sql = " UPDATE CONTARECEBER
                  SET IDREPFOSCNC  = :IDREPFOSCNC,
                      DSCONTAREC   = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', '')
                 WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    public function findNrestabelec($params){
        try{
            $sql = "SELECT NRESTABELEC 
            FROM ESTABELECIMENTO
             WHERE CDESTABELEC = :CDESTABELEC";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
            
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function findNrproduto($params){
        try{
            $sql = "SELECT NRPRODUTOADQ 
            FROM PRODUTOADQ
             WHERE NMPRODUTOADQ = :NMPRODUTOADQ";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
            
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function findVendasConciliadas($params){
        try{
            $sql = "
            SELECT DISTINCT C.CDFILIAL, C.DTVENDA, C.CDTIPORECE, P.NRPRODUTOADQ
                 FROM CONSMOVCAIXA C, RETVENDAADQ R, PRODUTOADQ P
                WHERE C.NRCONCLANC = :NRCONCLANC
                  AND C.CDFILIALNF = R.CDFILIAL
                  AND C.NRLANCTONF = R.NRLANCTONF
                  AND C.NRCONCLANC = R.NRCONCLANC
                  AND R.NRPRODUTOADQ = P.NRPRODUTOADQ
            ";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetch();
        } catch(\Exception $e){
            throw $e;
        }
    }
    
    public function contabilizaContaCnc($params){
      try{ 
            $procedure = new StoredProcedure($this->connection, 'CONTABILIZA_CONTAS_CNC');
            $procedure->addParam(new Param('CDFILIAL', Param::PARAM_INPUT, $params["CDFILIAL"]));
            $procedure->addParam(new Param('DTVENDA', Param::PARAM_INPUT, $params["DTVENDA"]));
            $procedure->addParam(new Param('CDTIPORECE', Param::PARAM_INPUT, $params["CDTIPORECE"]));
         
            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function findVendasConciliadasOld($params){
        $sql = "
        SELECT DISTINCT C.CDFILIAL, C.DTVENDA, P.CDTIPORECE, D.VRESPERADO, D.VRENCONTRADO
                    FROM CONSMOVCAIXA C, RETVENDAADQ R, TIPODIVERGENCIA T, DIVCONCILIACAO D, PRODUTOADQ P
                   WHERE C.NRCONCLANC = :NRCONCLANC
                    AND C.CDFILIALNF = R.CDFILIAL
                    AND C.NRLANCTONF = R.NRLANCTONF
                    AND C.NRCONCLANC = R.NRCONCLANC
                    AND D.NRCONSMOVCAIXA = C.NRCONSMOVCAIXA
                    AND D.NRRETVENDAADQ = R.NRRETVENDAADQ
                    AND D.NRTPDIVERGENCIA = T.NRTPDIVERGENCIA
                    AND T.IDDIVERGENCIA = 'P'
                    AND D.VRESPERADO = P.NRPRODUTOADQ
                    AND TRIM(D.VRENCONTRADO) = TRIM(TO_CHAR(:NRPRODUTOADQ))
        ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function insertDivergenciaConciliacao($params){
        $sql = "
        INSERT INTO DIVCONCILIACAO
                  (NRDIVCONCILIACAO, NRCONCLANC, NRTPDIVERGENCIA,
                  NRRETVENDAADQ, NRCONSMOVCAIXA, NRORG, VRESPERADO, VRENCONTRADO)
                VALUES 
                  (:NRDIVCONCILIACAO, :NRCONCLANC, :NRTPDIVERGENCIA, 
                  :NRRETVENDAADQ, :NRCONSMOVCAIXA, :NRORG, :VRESPERADO, :VRENCONTRADO)
        ";
        
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function checkItemDivergencia($DSTIPODIV){
        $sql = "
        SELECT NRTPDIVERGENCIA 
        FROM TIPODIVERGENCIA
        WHERE UPPER(DSTIPODIV) LIKE UPPER(:DSTIPODIV)
        ";
        $std = $this->connection->prepare($sql);
        $std->execute($DSTIPODIV);
        return $std->fetchAll();
    }
    
    public function verificaDataPeriodoContabil($params){
        $sql = "SELECT 1 
                FROM CONTOPECTBL
                WHERE CDEMPRESA = :CDEMPRESA
                AND :DTVENDA BETWEEN DTINICCONT AND DTFINACONT";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function verificaDataControleFinanc($params){
        $sql = "SELECT TO_CHAR(TRUNC(DTINICIOINT), 'DD/MM/YYYY') DATA
                FROM CTRLDTFINCNC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function verificaEmpresaDataVenda($params){

        $sql = "
        SELECT DISTINCT NF.CDEMPRESA, CONS.DTVENDA 
            FROM CONSMOVCAIXA CONS, NOTAFISCAL NF 
            WHERE CONS.NRCONSMOVCAIXA = :NRCONSMOVCAIXA
            AND NF.NRORG = CONS.NRORG
            AND CONS.NRORG = :NRORG
            ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
        
    }
    
    public function deleteDivConciliacao ($params) {
        $sql = "DELETE FROM DIVCONCILIACAO
                WHERE NRORG = :NRORG
                  AND NRCONSMOVCAIXA = :NRCONSMOVCAIXA";
                  
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }

    public function existBoletRec($params){
        $sql = "SELECT DISTINCT B.CDFILIAL, NRLANBOLREC, VRFINALBREC, NRPARCBOLREC
              FROM BOLETRECEBER B
             WHERE CDFILIAL = :CDFILIAL
               AND CDCLIENTE = :CDCLIENTE
               AND CDEMPRESA = :CDEMPRESA
               AND DTVENBOLREC = :DTVENBOLREC
               AND EXISTS (SELECT 1
                             FROM CONTARECEBER C
                                JOIN NOTAFISCAL NF
                                  ON NF.CDFILIAL = C.CDFILIAL
                                  AND NF.NRLANCTONF = C.NRLANCTONF
                                    JOIN CONSMOVCAIXA CONS
                                      ON CONS.CDFILIALNF = NF.CDFILIAL
                                      AND CONS.NRLANCTONF = NF.NRLANCTONF
                            WHERE C.CDFILIBOLREC = B.CDFILIAL
                              AND C.NRLANBOLREC = B.NRLANBOLREC
                              AND C.CDTPCTRECEB = :CDTPCTRECEB
                              AND NF.IDSISTEMA = 'CNC'
                              AND CONS.IDCONCILIADO = 'C')
                AND ROWNUM = 1
              ORDER BY 2 DESC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function updateBoletReceber($params){
        $sql = "UPDATE BOLETRECEBER
        SET VRFINALBREC = :VRFINALBREC
        WHERE CDFILIAL = :CDFILIAL
          AND NRLANBOLREC = :NRLANBOLREC";
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function verifyContaReceberInfo($params){
        $sql = "SELECT CDFILIBOLREC, NRLANBOLREC, VRATUAREC
                FROM CONTARECEBER
                WHERE NRLANCTONF = :NRLANCTONF
                  AND  CDFILIAL  = :CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }

    public function verifyBoletReceberInfo($params){
        $sql = "SELECT VRFINALBREC FROM BOLETRECEBER
            WHERE CDFILIAL = :CDFILIBOLREC 
            AND NRLANBOLREC = :NRLANBOLREC";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function clearBolRecebFromContaReceb($params){
        $sql = "    
        UPDATE CONTARECEBER
            SET CDFILIBOLREC = NULL,
                NRLANBOLREC = NULL
            WHERE NRLANCTONF = :NRLANCTONF
              AND CDFILIAL   = :CDFILIAL";
              
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function calcNrDiasVenc($params){
        $sql = "         
        SELECT NVL(NVL(PR.NRDIASVENC, T.NRDIASADMI), 0)
           AS V_NRDIASVENC
           FROM TIPORECE T LEFT JOIN PARAVEND P
                                  ON P.CDFILIAL = :CDFILIAL
                           LEFT JOIN PRODUTOADQ PR
                             ON PR.CDTIPORECE = T.CDTIPORECE
          WHERE T.CDTIPORECE = :CDTIPORECE ";
          
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function verifyDataVenc($params){
        $sql="
        SELECT CNC_DATA_VENC(:CDFILIAL, :DTVENDA, :NRDIASVENC, :CDTIPORECE)
        AS V_DTVENCIMENTO
        FROM DUAL";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function updateContaReceberBol($params){
        $sql = "
        UPDATE CONTARECEBER
        SET CDFILIBOLREC = :CDFILIBOLREC,
            NRLANBOLREC  = :NRLANBOLREC
        WHERE NRLANCTONF = :NRLANCTONF
              AND CDFILIAL       = :CDFILIAL 
        ";
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
        
    }
    
    public function updateTprecboleto($params){
        $sql = "
        UPDATE TPRECBOLETO
        SET VRTPRECBOLR = :VRTPRECBOLR
        WHERE NRLANBOLREC = :NRLANBOLREC
              AND CDFILIAL   = :CDFILIAL 
        ";
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
        
    }

    public function deleteBoletReceber($params){
        $sql = "DELETE
            FROM BOLETRECEBER
            WHERE CDFILIAL = :CDFILIAL
              AND NRLANBOLREC = :NRLANBOLREC";
              
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }

    public function upateBoletoConta($params){
        $sql = "
            UPDATE CONTARECEBER 
               SET CDFILIBOLREC = NULL, 
                   NRLANBOLREC = NULL 
             WHERE CDFILIAL = :P_CDFILIAL 
               AND NRLANCTONF = :P_NRLANCTONF
        ";    
        $std  = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function createBoletRec($params){
      try{ 
            $procedure = new StoredProcedure($this->connection, 'GERA_BOLETOS_REC');
            $procedure->addParam(new Param('P_NRLANBOLREC', Param::PARAM_INPUT, $params["P_NRLANBOLREC"]));
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $params["P_CDFILIAL"]));
            $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $params["P_CDCLIENTE"]));
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $params["P_CDEMPRESA"]));
            $procedure->addParam(new Param('P_VRBOLREC', Param::PARAM_INPUT, $params["P_VRBOLREC"]));
            $procedure->addParam(new Param('P_DTVENBOL', Param::PARAM_INPUT, $params["P_DTVENBOL"]));
            $procedure->addParam(new Param('P_CDTIPORECE', Param::PARAM_INPUT, $params["P_CDTIPORECE"]));
            $procedure->addParam(new Param('P_NRCHEQUEVEND', Param::PARAM_INPUT, $params["P_NRCHEQUEVEND"]));
            $procedure->addParam(new Param('P_CDBANCHEQVEN', Param::PARAM_INPUT, $params["P_CDBANCHEQVEN"]));
            $procedure->addParam(new Param('P_CDAGECHEQVEN', Param::PARAM_INPUT, $params["P_CDAGECHEQVEN"]));
            $procedure->addParam(new Param('P_CDCNTCHEQVEN', Param::PARAM_INPUT, $params["P_CDCNTCHEQVEN"]));
            $procedure->addParam(new Param('P_CDREDUCONT', Param::PARAM_INPUT, $params["P_CDREDUCONT"]));
            $procedure->addParam(new Param('P_CDTPBAIXA', Param::PARAM_INPUT, $params["P_CDTPBAIXA"]));
            $procedure->addParam(new Param('P_DTVENDAECF', Param::PARAM_INPUT, $params["P_DTVENDAECF"]));

            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function verifyInfoTpReceb($params){
        $sql="
        SELECT NVL(P.CDREDUCONT, T.CDREDUCONT) CDREDUCONT
          FROM TIPORECE T, PARAVEND P
        WHERE T.CDTIPORECE = :CDTIPORECE
          AND P.CDFILIAL = :CDFILIAL";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();    
        
    }
    
    public function refazTaxaServFinanc($params) {
        try{ 
            $procedure = new StoredProcedure($this->connection, 'REFAZ_REC_TAXASERV_CNC');
            $procedure->addParam(new Param('P_NRCONSMOVCAIXA', Param::PARAM_INPUT, $params[":NRCONSMOVCAIXA"]));

            return $procedure->execute();
        } catch (\Exception $e) {
                throw $e;
        }
    }
    
    public function getCdcliente($nradquirente){
        $sql = "SELECT CDCLIENTE 
                    FROM ADQUIRENTE
                    WHERE NRADQUIRENTE = :NRADQUIRENTE ";
        $std = $this->connection->prepare($sql);
        $std->execute($nradquirente);     
        return $std->fetch();
        
    }
    
    public function updateClienteNf($params){
        try{
            $sql = " UPDATE NOTAFISCAL
                  SET CDCLIENTE  = :CDCLIENTE
                WHERE CDFILIAL = :CDFILIAL
                  AND NRLANCTONF = :NRLANCTONF ";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    public function updateContRecebDesc ($params) {
        $sql = "UPDATE CONTARECEBER
                SET DSCONTAREC  = REPLACE(DSCONTAREC, '(PROVISAO FOS/CONCILIADOR)-', ''),
                    IDREPFOSCNC = 'N'
                WHERE CDFILIAL   = :CDFILIALNF
                  AND NRLANCTONF = :NRLANCTONF";
                
        $std = $this->connection->prepare($sql);
        return $std->execute($params);
    }
    
    public function verifyContReceb($params){
        $sql = "SELECT 1 AS FLAGBOLETO
              FROM CONTARECEBER C
             WHERE C.CDFILIAL = :CDFILIAL
               AND C.NRLANCTONF = :NRLANCTONF
               AND C.IDSTATREC = 'B'  ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
}