<?php

namespace Teknisa\CNC\Services;

use Teknisa\CNC\Utilities;
use Teknisa\CNC\Factories;

class BandeiraCNC {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Factories\BandeiraFactory $bandeiraFactory)  {
		$this->entityManager 	= $entityManager;
		$this->bandeiraFactory  = $bandeiraFactory;
	}

	public function getFlags($row){
		$acquires = $this->bandeiraFactory->getFlags(array(
			':NRORG'    	 => $row['NRORG'],
            ':LABELBANDEIRA' => $row['LABELBANDEIRA']
        ));
		return $acquires;
	}
	
	public function loadFlagByname($params) {
        $NMBANDEIRA  = $params[0]['value'];

        $parameters = array(
            ':NMBANDEIRA'     => $NMBANDEIRA
        );
        $VendaConciliada = $this->bandeiraFactory->loadFlagByname($parameters);
        return $VendaConciliada;
    }

}