<?php

namespace Teknisa\CNC\Services;

use Teknisa\CNC\Factories\Cnc00500VendaPorAdquirente;
use Teknisa\Libs\Util\Environment;

class Cnc00500VendaPorAdquirenteService {

    protected $entityManager;
    protected $environment;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager,Environment $environment, Cnc00500VendaPorAdquirente $factory) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->factory = $factory;
    }
    
    public function getVendasPorAdquirente ($row) {
        if ($row["TIPORECE"] == 1) {
            $result = $this->factory->getVendasPorAdquirenteRecebidas(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $row["NRESTABELEC"],
                ":NRADQUIRENTE" => $row["NRADQUIRENTE"],
                ":DTVENDAINI"   => $row["DTVENDA"]["start"],
                ":DTVENDAEND"   => $row["DTVENDA"]["end"],
                ":TIPOVENDA"    => $row["TIPOVENDA"]
            ));
        } else {
            $result = $this->factory->getVendasPorAdquirentePrevistas(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $row["NRESTABELEC"],
                ":NRADQUIRENTE" => $row["NRADQUIRENTE"],
                ":DTVENDAINI"   => $row["DTVENDA"]["start"],
                ":DTVENDAEND"   => $row["DTVENDA"]["end"],
                ":TIPOVENDA"    => $row["TIPOVENDA"]
            ));
        }
        
        return $result;
    }
    
    public function selectDetails ($filter) {
        $ESTABELECIMENTOS = [];
        $ADQUIRENTES = [];
        if ($filter["TIPORECE"]["value"] === "1") {
            $details = $this->factory->getVendasPorAdqRecDetalhes(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $filter["NRESTABELEC"]["value"],
                ":NRADQUIRENTE" => $filter["NRADQUIRENTE"]["value"],
                ":DTVENDAINI"   => $filter["DTVENDA"]["value"][0],
                ":DTVENDAEND"   => $filter["DTVENDA"]["value"][1],
                ":TIPOVENDA"    => $filter["TIPOVENDA"]["value"]
            ));
            foreach ($details as $value) {
                array_push($ESTABELECIMENTOS, $value["NRESTABELEC"]);
                array_push($ADQUIRENTES, $value["NRADQUIRENTE"]);
            }
            if($filter["NRESTABELEC"]["value"] = 'T'){
                $filter["NRESTABELEC"]["value"] = array_reduce(array_unique($ESTABELECIMENTOS), function($acc, $ele) {
    		        	return $acc."|".$ele;
    		        }, "")."|";
            }
            if($filter["NRADQUIRENTE"]["value"] = 'T'){
    	        $filter["NRADQUIRENTE"]["value"] = array_reduce(array_unique($ADQUIRENTES), function($acc, $ele) {
    	        	return $acc."|".$ele;
    	        }, "")."|";
            }
            $result = $this->factory->selectDetailsFinanc(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $filter["NRESTABELEC"]["value"],
                ":NRADQUIRENTE" => $filter["NRADQUIRENTE"]["value"],
                ":DTVENDA_MIN"  => $filter["DTVENDA"]["value"][0],
                ":DTVENDA_MAX"  => $filter["DTVENDA"]["value"][1]
            ));
        } else {
            $details = $this->factory->getVendasPorAdqPrevDetalhes(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $filter["NRESTABELEC"]["value"],
                ":NRADQUIRENTE" => $filter["NRADQUIRENTE"]["value"],
                ":DTVENDAINI"   => $filter["DTVENDA"]["value"][0],
                ":DTVENDAEND"   => $filter["DTVENDA"]["value"][1],
                ":TIPOVENDA"    => $filter["TIPOVENDA"]["value"]
            ));
            foreach ($details as $value) {
                array_push($ESTABELECIMENTOS, $value["NRESTABELEC"]);
                array_push($ADQUIRENTES, $value["NRADQUIRENTE"]);
            }
            if($filter["NRESTABELEC"]["value"] = 'T'){
                $filter["NRESTABELEC"]["value"] = array_reduce(array_unique($ESTABELECIMENTOS), function($acc, $ele) {
    		        	return $acc."|".$ele;
    		        }, "")."|";
            }
            if($filter["NRADQUIRENTE"]["value"] = 'T'){
    	        $filter["NRADQUIRENTE"]["value"] = array_reduce(array_unique($ADQUIRENTES), function($acc, $ele) {
    	        	return $acc."|".$ele;
    	        }, "")."|";
            }
            $result = $this->factory->selectDetailsVendaAdq(array(
                ":NRORG"        => $this->environment->getNrOrgTrab(),
                ":NRESTABELEC"  => $filter["NRESTABELEC"]["value"],
                ":NRADQUIRENTE" => $filter["NRADQUIRENTE"]["value"],
                ":DTVENDA_MIN"  => $filter["DTVENDA"]["value"][0],
                ":DTVENDA_MAX"  => $filter["DTVENDA"]["value"][1]
            ));
        }
        
        return $result;
    }
}