<?php

namespace WebServiceCall\Repository\FileManager\FileClass;

class ConfigData {
    private $shouldReadFromDB;
    
    private $empresasIds;
    private $senhasEmpresas;
    
    private $proxyHost;
    private $proxyPort;
    private $proxyLogin;
    private $proxyPassword;

    public function __construct(array $configData) {
        $this->proxyHost             = $configData['PROXY_HOST'];
        $this->proxyLogin            = $configData['PROXY_PORT'];
        $this->proxyPassword         = $configData['PROXY_LOGIN'];
        $this->proxyPort             = $configData['PROXY_PASSWORD'];

        $this->empresasIds           = $configData['CNC_ID_EMPRESA_CONC'];
        $this->senhasEmpresas        = $configData['CNC_SENHA_CONC'];
        
        $this->daysToBeConciliated   = intval($configData['CNC_DAYS_TO_BE_CONCILIATED']);
        
        $this->shouldReadFromDB      = !!$configData['CNC_IS_PRODUCTION'];
    }
    
    public function shouldReadFromDB() {
        return $this->shouldReadFromDB;
    }
    
    public function setShouldReadFromDB($shouldReadFromDB) {
        $this->shouldReadFromDB = $shouldReadFromDB;
    }
    
    public function getEmpresasIds() {
        return $this->empresasIds;
    }
    
    public function setEmpresasIds($empresasIds) {
        $this->empresasIds = $empresasIds;
    }
    
    public function getSenhasEmpresas() {
        return $this->senhasEmpresas;
    }
    
    public function setSenhasEmpresas($senhasEmpresas) {
        $this->senhasEmpresas = $senhasEmpresas;
    }
    
    public function getProxyHost() {
        return $this->proxyHost;
    }
    
    public function setProxyHost($proxyHost) {
        $this->proxyHost = $proxyHost;
    }
    
    public function getProxyPort() {
        return $this->proxyPort;
    }
    
    public function setProxyPort($proxyPort) {
        $this->proxyPort = $proxyPort;
    }
    
    public function getProxyLogin() {
        return $this->proxyLogin;
    }
    
    public function setProxyLogin($proxyLogin) {
        $this->proxyLogin = $proxyLogin;
    }
    
    public function getProxyPassword() {
        return $this->proxyPassword;
    }
    
    public function setProxyPassword($proxyPassword) {
        $this->proxyPassword = $proxyPassword;
    }
    
    public function getDaysToBeConciliated() {
        return $this->daysToBeConciliated;
    }
    
    public function setDaysToBeConciliated($daysToBeConciliated) {
        $this->daysToBeConciliated = $daysToBeConciliated;
    }
}